%bcond_without mesa

%if %{without mesa}
%global configure_params --disable-glamor --disable-glx
%else
%global configure_params --enable-glamor --enable-glx
%endif

%global pkgname xorg-server

%global ansic_major 0
%global ansic_minor 4
%global videodrv_major 25
%global videodrv_minor 2
%global xinput_major 24
%global xinput_minor 4
%global extension_major 10
%global extension_minor 0

Summary:   X.Org X11 X server
Name:      xorg-x11-server
Version:   21.1.8
Release:   1%{?dist}
License:   MIT
URL:       http://www.x.org
Source0:   https://www.x.org/pub/individual/xserver/%{pkgname}-%{version}.tar.xz
Source2:   10-quirks.conf
Source3:   xserver.pamd
Source4:   http://svn.exactcode.de/t2/trunk/package/xorg/xorg-server/xvfb-run.sh
Source5:   xserver-sdk-abi-requires.release

Patch3000: 06_use-intel-only-on-pre-gen4.diff
Patch3001: 0001-xfree86-use-modesetting-driver-by-default-on-GeForce.patch
Patch3002: 0001-Fedora-hack-Make-the-suid-root-wrapper-always-start-.patch
# Reference: https://gitlab.com/redhat/centos-stream/rpms/xorg-x11-server/-/commit/631c5917b6967c3f90a972ff7568c45d19d2bc90
Patch3003: 0001-mustard-xfree86-Disable-the-PCI-probe-path.patch
# https://gitlab.freedesktop.org/xorg/xserver/-/issues/1378
Patch5000: add-libgbm-for-modesetting.patch

BuildRequires: libxcvt libxcvt-devel
BuildRequires: make automake autoconf libtool pkgconfig
BuildRequires: systemtap-sdt-devel git-core dbus-devel libepoxy-devel systemd-devel openssl-devel bison flex
BuildRequires: libXfont2-devel libXau-devel libxkbfile-devel libXres-devel libXv-devel libudev-devel
BuildRequires: libfontenc-devel libXtst-devel libXdmcp-devel libX11-devel libXext-devel libXinerama-devel libXi-devel
BuildRequires: libXt-devel libdmx-devel libXmu-devel libXrender-devel libXi-devel libXpm-devel libXaw-devel libXfixes-devel
BuildRequires: xorg-x11-util-macros >= 1.17
BuildRequires: xorg-x11-proto-devel >= 7.7-10
BuildRequires: xorg-x11-font-utils >= 7.2-11
BuildRequires: xorg-x11-xtrans-devel >= 1.3.2
BuildRequires: pixman-devel >= 0.30.0
BuildRequires: libpciaccess-devel >= 0.13.1 
BuildRequires: libdrm-devel >= 2.4.0 kernel-headers
BuildRequires: audit-libs-devel libselinux-devel >= 2.0.86-1
BuildRequires: pkgconfig(xcb-aux) pkgconfig(xcb-image) pkgconfig(xcb-icccm) pkgconfig(xcb-keysyms)
BuildRequires: pkgconfig(xcb-renderutil) pkgconfig(epoxy)
BuildRequires: pkgconfig(xshmfence) >= 1.1
%if %{with mesa}
BuildRequires: mesa-libgbm-devel mesa-libEGL-devel
BuildRequires: mesa-libGL-devel >= 9.2
%endif


%description
X.Org X11 X server


%package common
Summary:  Xorg server common files
Requires: pixman >= 0.30.0
Requires: xkeyboard-config xkbcomp

%description common
Common files shared among all X servers.


%package Xorg
Summary:  Xorg X server
Requires: xorg-x11-server-common >= %{version}-%{release}
Requires: system-setup-keyboard xorg-x11-drv-libinput
%if %{with mesa}
Requires: libEGL 
%endif
Provides: Xorg = %{version}-%{release}
Provides: Xserver
Provides: xorg-x11-server-wrapper = %{version}-%{release}
Provides: xserver-abi(ansic-%{ansic_major}) = %{ansic_minor}
Provides: xserver-abi(videodrv-%{videodrv_major}) = %{videodrv_minor}
Provides: xserver-abi(xinput-%{xinput_major}) = %{xinput_minor}
Provides: xserver-abi(extension-%{extension_major}) = %{extension_minor}
Provides: xorg-x11-glamor = %{version}-%{release}
Provides: xorg-x11-drv-modesetting = %{version}-%{release}

%description Xorg
X.org X11 is an open source implementation of the X Window System.
It provides the basic low level functionality which full fledged
graphical user interfaces (GUIs) such as GNOME and KDE are designed
upon.


%package Xnest
Summary:  A nested server
Requires: xorg-x11-server-common >= %{version}-%{release}
Provides: Xnest

%description Xnest
Xnest is an X server which has been implemented as an ordinary
X application.  It runs in a window just like other X applications,
but it is an X server itself in which you can run other software.
It is a very useful tool for developers who wish to test their
applications without running them on their real X server.


%package Xvfb
Summary:  A X Windows System virtual framebuffer X server
License:  MIT and GPLv2
Requires: xorg-x11-server-common >= %{version}-%{release}
Requires: xorg-x11-xauth
Provides: Xvfb

%description Xvfb
Xvfb (X Virtual Frame Buffer) is an X server that is able to run on
machines with no display hardware and no physical input devices.
Xvfb simulates a dumb framebuffer using virtual memory.  Xvfb does
not open any devices, but behaves otherwise as an X display.  Xvfb
is normally used for testing servers.


%package Xephyr
Summary:  A nested server
Requires: xorg-x11-server-common >= %{version}-%{release}
Provides: Xephyr

%description Xephyr
Xephyr is an X server which has been implemented as an ordinary
X application.  It runs in a window just like other X applications,
but it is an X server itself in which you can run other software.
It is a very useful tool for developers who wish to test their
applications without running them on their real X server.  Unlike
Xnest, Xephyr renders to an X image rather than relaying the
X protocol, and therefore supports the newer X extensions like
Render and Composite.


%package devel
Summary:  SDK for X server driver module development
Requires: xorg-x11-util-macros
Requires: xorg-x11-proto-devel
Requires: libXfont2-devel
Requires: pkgconfig pixman-devel libpciaccess-devel
Provides: xorg-x11-server-static
Provides: xorg-x11-glamor-devel = %{version}-%{release}

%description devel
The SDK package provides the developmental files which are necessary for
developing X server driver modules, and for compiling driver modules
outside of the standard X11 source code tree.  Developers writing video
drivers, input drivers, or other X modules should install this package.


%package source
Summary:  Xserver source code required to build VNC server (Xvnc)
BuildArch: noarch

%description source
Xserver source code needed to build VNC server (Xvnc)


%prep
%autosetup -n %{pkgname}-%{version} -S git -p1

getmajor() {
    grep -i ^#define.ABI.$1_VERSION hw/xfree86/common/xf86Module.h |
    tr '(),' '   ' | awk '{ print $4 }'
}
getminor() {
    grep -i ^#define.ABI.$1_VERSION hw/xfree86/common/xf86Module.h |
    tr '(),' '   ' | awk '{ print $5 }'
}
test `getmajor ansic` == %{ansic_major}
test `getminor ansic` == %{ansic_minor}
test `getmajor videodrv` == %{videodrv_major}
test `getminor videodrv` == %{videodrv_minor}
test `getmajor xinput` == %{xinput_major}
test `getminor xinput` == %{xinput_minor}
test `getmajor extension` == %{extension_major}
test `getminor extension` == %{extension_minor}


%build
export CFLAGS="%{optflags} -specs=/usr/lib/rpm/%{_vendor}/%{_vendor}-hardened-cc1"
export CXXFLAGS="%{optflags} -specs=/usr/lib/rpm/%{_vendor}/%{_vendor}-hardened-cc1"
export LDFLAGS="%{build_ldflags} -specs=/usr/lib/rpm/%{_vendor}/%{_vendor}-hardened-ld"

%global no_int10 --disable-vbe --disable-int10-module

autoreconf -fiv

%configure --enable-xvfb \
	--enable-xnest \
	--enable-kdrive \
	--enable-xephyr \
	--enable-xorg \
	--enable-dependency-tracking \
	--disable-static \
	--with-pic \
	--without-dtrace \
	--disable-linux-acpi \
	--disable-linux-apm \
	--enable-xselinux \
	--enable-record \
	--enable-present \
	--enable-xcsecurity \
	--enable-config-udev \
	--disable-unit-tests \
	--disable-dri \
	--enable-dri2 \
	--enable-suid-wrapper \
	--with-default-font-path="catalogue:/etc/X11/fontpath.d,built-ins" \
	--with-module-dir=%{_libdir}/xorg/modules \
	--with-builderstring="Build ID: %{name} %{version}-%{release}" \
	--with-xkb-output=%{_localstatedir}/lib/xkb \
	%{?no_int10} \
	%{configure_params} \
	${CONFIGURE}

%make_build


%install
%make_install

mkdir -p  %{buildroot}%{_datadir}/X11/xorg.conf.d
install -m 644 %{SOURCE2}  %{buildroot}%{_datadir}/X11/xorg.conf.d

mkdir -p  %{buildroot}%{_libdir}/xorg/modules/{drivers,input}
mkdir -p  %{buildroot}%{_sysconfdir}/pam.d
install -m 644 %{SOURCE3}  %{buildroot}%{_sysconfdir}/pam.d/xserver

mkdir -p  %{buildroot}%{_sysconfdir}/X11/xorg.conf.d
install -m 0755 %{SOURCE4}  %{buildroot}%{_bindir}/xvfb-run
install -m 755 %{SOURCE5}  %{buildroot}%{_bindir}/xserver-sdk-abi-requires

%global inst_srcdir %{buildroot}%{_datadir}/xorg-x11-server-source

mkdir -p %{inst_srcdir}/{Xext,xkb,GL,hw/{xquartz/bundle,xfree86/common}}
mkdir -p %{inst_srcdir}/{hw/dmx/doc,man,doc,hw/dmx/doxygen}
cp {,%{inst_srcdir}/}hw/xquartz/bundle/cpprules.in
cp {,%{inst_srcdir}/}man/Xserver.man
cp {,%{inst_srcdir}/}doc/smartsched
cp {,%{inst_srcdir}/}xserver.ent.in
cp {,%{inst_srcdir}/}hw/xfree86/Xorg.sh.in
cp xkb/README.compiled %{inst_srcdir}/xkb
cp hw/xfree86/xorgconf.cpp %{inst_srcdir}/hw/xfree86

find . -type f | egrep '.*\.(c|h|am|ac|inc|m4|h.in|pc.in|man.pre|pl|txt)$' |
xargs tar cf - | (cd %{inst_srcdir} && tar xf -)
find %{inst_srcdir}/hw/xfree86 -name \*.c -delete

find  %{buildroot} -type f -name '*.la' -delete
%ifnarch x86_64
    rm -f  %{buildroot}%{_libdir}/xorg/modules/lib{int10,vbe}.so
%endif


%files common
%license COPYING
%{_mandir}/man1/Xserver.1*
%{_libdir}/xorg/protocol.txt
%dir %{_localstatedir}/lib/xkb
%{_localstatedir}/lib/xkb/README.compiled
%global Xorgperms %attr(4755, root, root)


%files Xorg
%config %attr(0644,root,root) %{_sysconfdir}/pam.d/xserver
%{_bindir}/X
%{_bindir}/Xorg
%{_libexecdir}/Xorg
%{Xorgperms} %{_libexecdir}/Xorg.wrap
%{_bindir}/gtf
%dir %{_libdir}/xorg
%dir %{_libdir}/xorg/modules
%dir %{_libdir}/xorg/modules/drivers
%{_libdir}/xorg/modules/drivers/modesetting_drv.so
%dir %{_libdir}/xorg/modules/input
%{_libdir}/xorg/modules/input/inputtest_drv.so
%if %{with mesa}
%dir %{_libdir}/xorg/modules/extensions
%{_libdir}/xorg/modules/extensions/libglx.so
%{_libdir}/xorg/modules/libglamoregl.so
%endif
%{_libdir}/xorg/modules/libfbdevhw.so
%{_libdir}/xorg/modules/libexa.so
%{_libdir}/xorg/modules/libshadow.so
%{_libdir}/xorg/modules/libshadowfb.so
%{_libdir}/xorg/modules/libvgahw.so
%{_libdir}/xorg/modules/libwfb.so
%{_mandir}/man1/gtf.1*
%{_mandir}/man1/Xorg.1*
%{_mandir}/man1/Xorg.wrap.1*
%{_mandir}/man4/fbdevhw.4*
%{_mandir}/man4/exa.4*
%{_mandir}/man4/inputtestdrv.4.gz
%{_mandir}/man4/modesetting.4*
%{_mandir}/man5/Xwrapper.config.5*
%{_mandir}/man5/xorg.conf.5*
%{_mandir}/man5/xorg.conf.d.5*
%dir %{_sysconfdir}/X11/xorg.conf.d
%dir %{_datadir}/X11/xorg.conf.d
%{_datadir}/X11/xorg.conf.d/10-quirks.conf


%files Xnest
%{_bindir}/Xnest
%{_mandir}/man1/Xnest.1*


%files Xvfb
%{_bindir}/Xvfb
%{_bindir}/xvfb-run
%{_mandir}/man1/Xvfb.1*


%files Xephyr
%{_bindir}/Xephyr
%{_mandir}/man1/Xephyr.1*


%files devel
%license COPYING
%{_bindir}/xserver-sdk-abi-requires
%{_libdir}/pkgconfig/xorg-server.pc
%dir %{_includedir}/xorg
%{_includedir}/xorg/*.h
%{_datadir}/aclocal/xorg-server.m4


%files source
%{_datadir}/xorg-x11-server-source


%changelog
* Tue Aug 1 2023 Shuo Wang <abushwang@tencent.com> - 21.1.8-1
- update to 21.1.8

* Tue May 23 2023 Xin Cheng <denisecheng@tencent.com> - 21.1.4-7
- Replace OpencloudOS with %{_vendor}

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 21.1.4-6
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 21.1.4-5
- Rebuilt for OpenCloudOS Stream 23

* Mon Feb 27 2023 Xiaojie Chen <jackxjchen@tencent.com> - 21.1.4-4
- Disable the PCI-specific driver probe

* Fri Feb 24 2023 ZoeDong <zoedong@tencent.com> - 21.1.4-3
- add libgbm for modesetting
- remove the defination of int10_arch
- disable dri3

* Thu Feb 23 2023 ZoeDong <zoedong@tencent.com> - 21.1.4-2
- enable mesa

* Mon Oct 10 2022 ZoeDong <zoedong@tencent.com> - 21.1.4-1
- Initial build
